Summary:        LMDB Abstraction Layer
Name:           lmdbal
# All code execpt
# is available under GPL-3.0-or-later
License:        GPL-3.0-only AND GPL-3.0-or-later

Version:        0.5.4
Release:        1%{?dist}

URL:            https://git.macaw.me/blue/lmdbal
Source:         %{url}/archive/%{version}.tar.gz
# Generate only man pages
# https://git.macaw.me/blue/lmdbal/pulls/2
Patch:          doc.patch

BuildRequires:  cmake >= 3.16
BuildRequires:  doxygen
BuildRequires:  gcc-c++
BuildRequires:  gtest-devel
BuildRequires:  make
BuildRequires:  lmdb-devel
BuildRequires:  qt5-qtbase-devel

%description
A Qt based library to ease interactions with Lightening Memory Data Base.

%package devel
Summary:        LMDB Abstraction Layer
Requires:       %{name}%{?_isa} = %{version}-%{release}
Requires:       lmdb-devel
Requires:       qt5-qtbase-devel

%description devel
Development files for Lightening Memory Data Base Abstraction Layer.


%prep
%autosetup -p 1 -n %{name}
# Build tests with default optimization levels
sed -i 's/PRIVATE -fPIC -Wall -Wextra -O0/PRIVATE -fPIC -Wall -Wextra/g' \
    test/CMakeLists.txt

%build
# Use Qt5 for now as main dependency squawk currently uses Qt5
%cmake -DBUILD_STATIC=False \
       -DBUILD_TESTS=True \
       -DBUILD_DOC=True \
       -DQT_VERSION_MAJOR=5 \
       -DBUILD_DOXYGEN_AWESOME=False \
       -DBUILD_DOC_MAN=True \
       -DBUILD_DOC_HTML=False \
       -DBUILD_DOC_XML=False

%cmake_build

%install
%cmake_install
# Move documentation into correct location
mkdir -p %{buildroot}%{_mandir}
mv %{buildroot}/usr/share/doc/LMDBAL/man/man3 %{buildroot}%{_mandir}/

%check
# Run tests
%{_builddir}/%{name}/%{_vpath_builddir}/test/runUnitTests

%files
%license LICENSE.md
%doc README.md
%doc CHANGELOG.md
%{_libdir}/libLMDBAL.so.1

%files devel
%{_libdir}/libLMDBAL.so
%dir %{_libdir}/cmake/%{name}
%{_libdir}/cmake/%{name}/*.cmake
%dir %{_includedir}/%{name}
%{_includedir}/%{name}/*.h
%{_includedir}/%{name}/*.hpp
%{_mandir}/man3/LMDBAL_Base.3*
%{_mandir}/man3/LMDBAL_Cache.3*
%{_mandir}/man3/LMDBAL_Closed.3*
%{_mandir}/man3/LMDBAL_Cursor.3*
%{_mandir}/man3/LMDBAL_CursorEmpty.3*
%{_mandir}/man3/LMDBAL_CursorNotReady.3*
%{_mandir}/man3/LMDBAL_Directory.3*
%{_mandir}/man3/LMDBAL_Exception.3*
%{_mandir}/man3/LMDBAL_Exist.3*
%{_mandir}/man3/LMDBAL_iStorage.3*
%{_mandir}/man3/LMDBAL_NotFound.3*
%{_mandir}/man3/LMDBAL_Opened.3*
%{_mandir}/man3/LMDBAL_Serializer.3*
%{_mandir}/man3/LMDBAL_Serializer_\ double\ _.3*
%{_mandir}/man3/LMDBAL_Serializer_\ float\ _.3*
%{_mandir}/man3/LMDBAL_Serializer_\ int16_t\ _.3*
%{_mandir}/man3/LMDBAL_Serializer_\ int32_t\ _.3*
%{_mandir}/man3/LMDBAL_Serializer_\ int64_t\ _.3*
%{_mandir}/man3/LMDBAL_Serializer_\ int8_t\ _.3*
%{_mandir}/man3/LMDBAL_Serializer_\ QByteArray\ _.3*
%{_mandir}/man3/LMDBAL_Serializer_\ QString\ _.3*
%{_mandir}/man3/LMDBAL_Serializer_\ std_string\ _.3*
%{_mandir}/man3/LMDBAL_Serializer_\ uint16_t\ _.3*
%{_mandir}/man3/LMDBAL_Serializer_\ uint32_t\ _.3*
%{_mandir}/man3/LMDBAL_Serializer_\ uint64_t\ _.3*
%{_mandir}/man3/LMDBAL_Serializer_\ uint8_t\ _.3*
%{_mandir}/man3/LMDBAL_Storage.3*
%{_mandir}/man3/LMDBAL_StorageDuplicate.3*
%{_mandir}/man3/LMDBAL_Transaction.3*
%{_mandir}/man3/LMDBAL_TransactionTerminated.3*
%{_mandir}/man3/LMDBAL_Unknown.3*
%{_mandir}/man3/LMDBAL_WriteTransaction.3*


%changelog
* Tue Oct 1 2024 Benson Muite <benson_muite@emailplus.org> - 0.5.4-1
- Initial package
